• Login
sketchucation logo sketchucation
  • Login
πŸ€‘ SketchPlus 1.3 | 44 Tools for $15 until June 20th Buy Now

Shadow Control Possible? (solved)

Scheduled Pinned Locked Moved Developers' Forum
10 Posts 3 Posters 5.9k Views
Loading More Posts
  • Oldest to Newest
  • Newest to Oldest
  • Most Votes
Reply
  • Reply as topic
Log in to reply
This topic has been deleted. Only users with topic management privileges can see it.
  • R Offline
    renderiza
    last edited by renderiza 22 Jun 2013, 19:34

    Hi,

    I want to create a plugin that will set scenes with different rendering styles so I can then export them to Photoshop.

    To get better idea of what I want to create through code please open this LINK to see the rendering setting to set scenes for Color, Shadows, Alpha Channel and ZDeapth.

    I can't seem to find a way to control Shadows parameter like 'Light' and 'Dark' values. Also the only way to active Shadows through code that I know of is this the following...

    Sketchup.send_action(1213)

    ...

    I am just starting this so I don't have much but here is a WIP to creat aplha channel (still not complete).

    
    
    ##################
    ###Alpha Channe###
    ##################
    
    Sketchup.active_model.rendering_options['DisplayFog']=false
    Sketchup.active_model.rendering_options['BackgroundColor']=[0, 0, 0]
    #Ground
    Sketchup.active_model.rendering_options['DrawGround']=false
    #Sky
    Sketchup.active_model.rendering_options['DrawHorizon']=false
    #EndPoint (lines)
    Sketchup.active_model.rendering_options['DrawLineEnds']=false
    #Profile (lines)
    Sketchup.active_model.rendering_options['DrawSilhouettes']=false
    #Display Lines?
    Sketchup.active_model.rendering_options['EdgeDisplayMode']=0
    #Back Face Color
    Sketchup.active_model.rendering_options['FaceBackColor']=[255, 255, 255]
    #Front Face Color
    Sketchup.active_model.rendering_options['FaceFrontColor']=[255, 255, 255]
    #Fog Color
    Sketchup.active_model.rendering_options['FogColor']=[255, 255, 255]
    

    If anyone can help me I will be very greatfull. Thanks!

    [url=https://www.sketchupcode.com/:z3kqsidd]My Extensions ...[/url:z3kqsidd]

    1 Reply Last reply Reply Quote 0
    • T Offline
      TIG Moderator
      last edited by 22 Jun 2013, 21:31

      You also need to consider the shadow_info and its ['Light'] & ['Dark'] settings [%] ?

      TIG

      1 Reply Last reply Reply Quote 0
      • R Offline
        renderiza
        last edited by 22 Jun 2013, 22:01

        For example if I want to set the Alpha Channel scene I need to set the following shadow settings with code...

        Shadow Settings:

        Use Shadow = false
        Light = 0
        Dark = 100
        Use sun for shading = true

        If I am not mistaken the shadow_info Api is only to extract their values so it cannot let me set their values right?

        ...

        Maybe the solution is to provide SketchUp File with all the scenes with styles settings already provided and just import the them somehow but not sure if that is possible. I need to do some more research! πŸ€“

        [url=https://www.sketchupcode.com/:z3kqsidd]My Extensions ...[/url:z3kqsidd]

        1 Reply Last reply Reply Quote 0
        • T Offline
          TIG Moderator
          last edited by 22 Jun 2013, 22:11

          No. πŸ˜’

          Play around in the Ruby Console to see what changing things does...

          Sketchup.active_model.shadow_info['Dark']=0 Sketchup.active_model.shadow_info['Light']=100

          Will both change things as you might expect πŸ˜•

          TIG

          1 Reply Last reply Reply Quote 0
          • R Offline
            renderiza
            last edited by 22 Jun 2013, 22:38

            WOW!

            TIG, did I said you are awesome! 😍

            Thanks!

            [url=https://www.sketchupcode.com/:z3kqsidd]My Extensions ...[/url:z3kqsidd]

            1 Reply Last reply Reply Quote 0
            • R Offline
              renderiza
              last edited by 23 Jun 2013, 00:41

              The following is the code for creating an Alpha Channel Scene...

              
              ##################
              ###Alpha Channe###
              ##################
              
              ###Create Scene###
              Sketchup.send_action(CMD_PAGE_NEW)
              
              ###Style###
              Sketchup.active_model.rendering_options['RenderMode']=5
              
              #Edge Settings
              Sketchup.active_model.rendering_options['EdgeDisplayMode']=0
              Sketchup.active_model.rendering_options['DrawSilhouettes']=false
              
              #Face Settings
              Sketchup.active_model.rendering_options['FaceFrontColor']=[255, 255, 255]
              Sketchup.active_model.rendering_options['FaceBackColor']=[255, 255, 255]
              
              #Background Settings
              Sketchup.active_model.rendering_options['BackgroundColor']=[0, 0, 0]
              Sketchup.active_model.rendering_options['DrawHorizon']=false
              Sketchup.active_model.rendering_options['DrawGround']=false
              
              #Watermark Settings
              Sketchup.active_model.rendering_options['DisplayWatermarks']=false
              
              
              ###Shadow Settings###
              Sketchup.active_model.shadow_info['DisplayShadows']=false
              Sketchup.active_model.shadow_info['UseSunForAllShading']=true 
              Sketchup.active_model.shadow_info['Light']=0
              Sketchup.active_model.shadow_info['Dark']=100
              
              ###Fog Settings###
              Sketchup.active_model.rendering_options['DisplayFog']=false
              
              
              ############
              ###Update###
              ############
              model = Sketchup.active_model 
              pages = model.pages 
              c_page = pages.selected_page 
              
              c_page.update
              
              

              Only thing I wish didn't happen is the Warning! message saying "You are creating or updating a scene and have not saved the changes you've made to your style."

              Is there a way to get rid of that?

              Anyways just wanted to post what I had so far...thanks!

              [url=https://www.sketchupcode.com/:z3kqsidd]My Extensions ...[/url:z3kqsidd]

              1 Reply Last reply Reply Quote 0
              • R Offline
                renderiza
                last edited by 23 Jun 2013, 01:12

                Here is an interesting plugin...

                Rendering Favourites (v1.1) by Trogluddite - This is a plugin which can store style options and its great to store things like Alpha Channels, ZDeapth, Color, ect.

                [url=https://www.sketchupcode.com/:z3kqsidd]My Extensions ...[/url:z3kqsidd]

                1 Reply Last reply Reply Quote 0
                • R Offline
                  renderiza
                  last edited by 23 Jun 2013, 19:41

                  Hi,

                  Here is what I assume to be a BUG... When the code creates the Zdepth page even though the Fog settings appear to be applied it doesn't display it! This is strange and for it to work I need to move the distance slider a nudge manually which defeats the purpose. πŸ˜•

                  Here is the code...Notice I saved the style properties into folder and I am just importing them so the rest of the code works on Shadow & Fog properties.

                  model = Sketchup.active_model 
                  pages = model.pages 
                  
                  
                  ########################################
                  ###Aplha################################
                  ########################################
                  
                  ###Shadow Settings###
                  Sketchup.active_model.shadow_info['DisplayShadows']=false
                  Sketchup.active_model.shadow_info['UseSunForAllShading']=true 
                  Sketchup.active_model.shadow_info['Light']=0
                  Sketchup.active_model.shadow_info['Dark']=100
                  
                  ###Fog Settings###
                  Sketchup.active_model.rendering_options['DisplayFog']=false
                  
                  
                  pages.add("Aplha")
                  styles = Sketchup.active_model.styles
                  status = styles.add_style "c;\\styles\\Aplha Style.style", true
                  
                  selpage = pages.selected_page 
                  selpage.update
                  
                  
                  ########################################
                  ###Zdepth###############################
                  ########################################
                  
                  ###Shadow Settings###
                  Sketchup.active_model.shadow_info['DisplayShadows']=false
                  Sketchup.active_model.shadow_info['UseSunForAllShading']=true 
                  Sketchup.active_model.shadow_info['Light']=0
                  Sketchup.active_model.shadow_info['Dark']=100
                  
                  ###Fog Settings###
                  Sketchup.active_model.rendering_options["FogEndDist"]=35.m
                  Sketchup.active_model.rendering_options['DisplayFog']=true
                  
                  
                  pages.add("Zdepth")
                  styles = Sketchup.active_model.styles
                  status = styles.add_style "c;\\styles\\Zdepth Style.style", true
                  
                  selpage = pages.selected_page 
                  selpage.update
                  

                  Any help will be appreciated! πŸ‘

                  [url=https://www.sketchupcode.com/:z3kqsidd]My Extensions ...[/url:z3kqsidd]

                  1 Reply Last reply Reply Quote 0
                  • R Offline
                    renderiza
                    last edited by 23 Jun 2013, 23:45

                    Seems the Fog part is working now but not sure what was that I did to fix it. For the most part I think I am finish but just need to worry about the interface part of things now.

                    model = Sketchup.active_model 
                    pages = model.pages 
                    
                    ########################################
                    ###Alpha################################
                    ########################################
                    
                    ###Shadow Settings###
                    Sketchup.active_model.shadow_info['DisplayShadows']=false
                    Sketchup.active_model.shadow_info['UseSunForAllShading']=true 
                    Sketchup.active_model.shadow_info['Light']=0
                    Sketchup.active_model.shadow_info['Dark']=100
                    
                    ###Fog Settings###
                    Sketchup.active_model.rendering_options['DisplayFog']=false
                    
                    ###Add Page###
                    pages.add("Alpha")
                    styles = Sketchup.active_model.styles
                    status = styles.add_style "c;\\styles\\Alpha Style.style", true
                    
                    ###Update###
                    selpage = pages.selected_page 
                    selpage.update
                    
                    
                    ########################################
                    ###Cley#################################
                    ########################################
                    
                    ###Shadow Settings###
                    Sketchup.active_model.shadow_info['DisplayShadows']=false
                    Sketchup.active_model.shadow_info['UseSunForAllShading']=true 
                    Sketchup.active_model.shadow_info['Light']=50
                    Sketchup.active_model.shadow_info['Dark']=15
                    
                    ###Fog Settings###
                    Sketchup.active_model.rendering_options['DisplayFog']=false
                    
                    ###Add Page###
                    pages.add("Cley")
                    styles = Sketchup.active_model.styles
                    status = styles.add_style "c;\\styles\\Cley Style.style", true
                    
                    ###Update###
                    selpage = pages.selected_page 
                    selpage.update
                    
                    
                    ########################################
                    ###Color################################
                    ########################################
                    
                    ###Shadow Settings###
                    Sketchup.active_model.shadow_info['DisplayShadows']=false
                    Sketchup.active_model.shadow_info['UseSunForAllShading']=true 
                    Sketchup.active_model.shadow_info['Light']=0
                    Sketchup.active_model.shadow_info['Dark']=100
                    
                    ###Fog Settings###
                    Sketchup.active_model.rendering_options['DisplayFog']=false
                    
                    ###Add Page###
                    pages.add("Color")
                    styles = Sketchup.active_model.styles
                    status = styles.add_style "c;\\styles\\Color Style.style", true
                    
                    ###Update###
                    selpage = pages.selected_page 
                    selpage.update
                    
                    
                    ########################################
                    ###Color by Layer#######################
                    ########################################
                    
                    ###Shadow Settings###
                    Sketchup.active_model.shadow_info['DisplayShadows']=false
                    Sketchup.active_model.shadow_info['UseSunForAllShading']=true 
                    Sketchup.active_model.shadow_info['Light']=0
                    Sketchup.active_model.shadow_info['Dark']=100
                    
                    ###Fog Settings###
                    Sketchup.active_model.rendering_options['DisplayFog']=false
                    
                    ###Add Page###
                    pages.add("Color by Layer")
                    styles = Sketchup.active_model.styles
                    status = styles.add_style "c;\\styles\\Color by Layer Style.style", true
                    
                    ###Update###
                    selpage = pages.selected_page 
                    selpage.update
                    
                    
                    ########################################
                    ###Line################################
                    ########################################
                    
                    ###Shadow Settings###
                    Sketchup.active_model.shadow_info['DisplayShadows']=false
                    Sketchup.active_model.shadow_info['UseSunForAllShading']=true 
                    Sketchup.active_model.shadow_info['Light']=0
                    Sketchup.active_model.shadow_info['Dark']=100
                    
                    ###Fog Settings###
                    Sketchup.active_model.rendering_options['DisplayFog']=false
                    
                    ###Add Page###
                    pages.add("Line")
                    styles = Sketchup.active_model.styles
                    status = styles.add_style "c;\\styles\\Line Style.style", true
                    
                    ###Update###
                    selpage = pages.selected_page 
                    selpage.update
                    
                    
                    ########################################
                    ###Profile##############################
                    ########################################
                    
                    ###Shadow Settings###
                    Sketchup.active_model.shadow_info['DisplayShadows']=false
                    Sketchup.active_model.shadow_info['UseSunForAllShading']=true 
                    Sketchup.active_model.shadow_info['Light']=0
                    Sketchup.active_model.shadow_info['Dark']=100
                    
                    ###Fog Settings###
                    Sketchup.active_model.rendering_options['DisplayFog']=false
                    
                    ###Add Page###
                    pages.add("Profile")
                    styles = Sketchup.active_model.styles
                    status = styles.add_style "c;\\styles\\Profile Style.style", true
                    
                    ###Update###
                    selpage = pages.selected_page 
                    selpage.update
                    
                    
                    ########################################
                    ###Shadow################################
                    ########################################
                    
                    ###Shadow Settings###
                    Sketchup.active_model.shadow_info['DisplayShadows']=true
                    Sketchup.active_model.shadow_info['UseSunForAllShading']=true 
                    Sketchup.active_model.shadow_info['Light']=100
                    Sketchup.active_model.shadow_info['Dark']=0
                    
                    ###Fog Settings###
                    Sketchup.active_model.rendering_options['DisplayFog']=false
                    
                    ###Add Page###
                    pages.add("Shadow")
                    styles = Sketchup.active_model.styles
                    status = styles.add_style "c;\\styles\\Shadow Style.style", true
                    
                    ###Update###
                    selpage = pages.selected_page 
                    selpage.update
                    
                    
                    ########################################
                    ###Texture################################
                    ########################################
                    
                    ###Shadow Settings###
                    Sketchup.active_model.shadow_info['DisplayShadows']=false
                    Sketchup.active_model.shadow_info['UseSunForAllShading']=true 
                    Sketchup.active_model.shadow_info['Light']=0
                    Sketchup.active_model.shadow_info['Dark']=100
                    
                    ###Fog Settings###
                    Sketchup.active_model.rendering_options['DisplayFog']=false
                    
                    ###Add Page###
                    pages.add("Texture")
                    styles = Sketchup.active_model.styles
                    status = styles.add_style "c;\\styles\\Texture Style.style", true
                    
                    ###Update###
                    selpage = pages.selected_page 
                    selpage.update
                    
                    
                    ########################################
                    ###Zdepth###############################
                    ########################################
                    
                    ###Shadow Settings###
                    Sketchup.active_model.shadow_info['DisplayShadows']=false
                    Sketchup.active_model.shadow_info['UseSunForAllShading']=true 
                    Sketchup.active_model.shadow_info['Light']=0
                    Sketchup.active_model.shadow_info['Dark']=100
                    
                    ###Fog Settings###
                    Sketchup.active_model.rendering_options['FogEndDist']=35.m
                    Sketchup.active_model.rendering_options['DisplayFog']=true
                    
                    ###Add Page###
                    pages.add("Zdepth")
                    styles = Sketchup.active_model.styles
                    status = styles.add_style "c;\\styles\\Zdepth Style.style", true
                    
                    ###Update###
                    selpage = pages.selected_page 
                    selpage.update
                    

                    [url=https://www.sketchupcode.com/:z3kqsidd]My Extensions ...[/url:z3kqsidd]

                    1 Reply Last reply Reply Quote 0
                    • M Offline
                      mrsailboat83
                      last edited by 17 Jul 2018, 02:24

                      dude, did you know that everytime you save a scene there is the option to save it with the current settings? Maybe this wasn't the case back in 2013 but there you go

                      1 Reply Last reply Reply Quote 0
                      • 1 / 1
                      • First post
                        Last post
                      Buy SketchPlus
                      Buy SUbD
                      Buy WrapR
                      Buy eBook
                      Buy Modelur
                      Buy Vertex Tools
                      Buy SketchCuisine
                      Buy FormFonts

                      Advertisement